;Detecteur de liquide.V2avec transistor  121213   Jauge  diodes  
;2 diodes en srie alimentes par un transistor 2N2222, courant d'environ 60mA
;Le principe: une jonction  semi conductrice  est alimente
;On mesure la tension V  ses bornes, de l'ordre de 2x800 = 1.6V.
;V est mesure une premire fois, V1, juste aprs l'tablissement de l'alimentation puis une deuxime fois,V2, aprs  30 s d'alimentation.
;Si les jonctions sont l'air libre, on constate que V2<V1, de quelques 20  30 mV.
;Si la jonction sont plonges dans un liquide quelconque, la diffrence V2-V1= 8  15  mV.
;Ceci permet de detecter si une jonction est  l'air libre ou immerge.
;En pratique les jonction utilise sont des diodes au silicium de type 1N4148 ou quivalent,  
;d'o un courant approximatif de 60mA. Il n'y a aucun chauffement detectable. 
;le convertisseur analogique numrique a un Vref = 2.5V soit environ 2.5mv par point
       list      p=16F88             ; list directive to define processor
       #include <p16F88.inc>         ; processor specific variable definitions
		ERRORLEVEL	-302			;pas de warnings pour les banks
;Program Configuration Register 1  PIEGE sur 16F88: il FAUT _HS_OSC meme  4MHz!!!
		__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_OFF & _WDT_Off & _HS_OSC
;		__CONFIG    _CONFIG2, _IESO_Off & _FCMEN_OFF
	
	#DEFINE	SEUIL	5				;Seuil pour HUM/SEC Avec 2.5mV par point cela fait SEUIL*2.5mV
	#DEFINE	DK1		PORTA,1			;DK1 pin18, 0 ou +5V commande le transistor
	#DEFINE	LED1			PORTB,0	
    cblock  h'20'   
	XTMP 
	TMP
	V1							;8LSB lecture  froid
	V2							;8LSB lecture aprs 30s de chauffage
	DIFF						;V1  - V2 	en valeur absolue	
	cs							;temporaire
	endc
		
START   ORG     0                    
  	    goto    Main
Main                                                                                                                                                                        	
		clrf	ANSEL			;toutes les entres en numerique et non en analogique
		banksel	0				;bk0
		call	INIT
deb		
		bsf		DK1		;alimenter diode						
		call		Lec2V			;lecture de V1 immdiate, diodes froides, puis 30s de chauffage et V2, calcul de DIFF
		movlw	SEUIL
		subwf	DIFF,w
		btfss	STATUS,C		;Si DIFF>SEUIL, sec
		goto	$+3				;<SEUIL  HUMIDE Led ON
		bcf		LED1			;>=SEUIL SEC, Led  OFF
		goto	$+2				;fini pour D,qui est donc sche
		bsf		LED1			;>SEUIL Humide	
		bcf		DK1				;D  off
		movlw	d'120'			; 30s off refroidissement
		call	Wait_ns
		goto	deb				;fin de cycle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CONV						;SUB conv A/D, sort avec w = V (8LSB)
	movlw	d'8'			; attente 2s  avant de lire
	call	Wait_ns
	bsf		ADCON0,ADON		;Alimenter A/D converter
	call	SetupDelay
	bsf		ADCON0,GO		;dmarrer conversion
	nop
	btfsc	ADCON0,GO		;1 tant que en cours
	goto	$-1
	bcf		ADCON0,ADON		;Arreter d'alimenter A/D converter
	banksel	ADRESL			;bk1
	movfw	ADRESL
	banksel	ADRESH			;bk0
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
INIT						;SUB
	bcf		INTCON,GIE		;pas d'IT
	bsf		INTCON,PEIE		;general peripheral IT enable
; Ne pas oublier de declarer en INPUT analogic la tension Vref 		
	banksel	TRISA			;bk1
	movlw	b'00001100'		;RA2 pin 1 input analog Vdiode,  RA3 pin 2 input Vref= 2.5V
	movwf	TRISA			;RA1 pin 18 ,output, vers la base du transistor							;
	movlw	b'00000000'		;RB0 pin 6 output 0 ou 5V pour LED1
	movwf	TRISB			;						
;;;;;;;;;;;;;;;;;;;registre  ANSEL;;;;;;;;;;;;;;;;;;;;;
	clrf	ANSEL			;Toutes entres en numrique car FF au demarrage!!
	bsf		ANSEL,2			;Dclare en entre analogique  RA2,pin 1, V diode
	bsf		ANSEL,3			;idem                          RA3, pin 2, pour Vref
;;;;;;;;;;;;ADCON1;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	bsf		ADCON1,ADFM		;result right justified, 6msb ds ADRESH = 0 en bk 0
	bcf		ADCON1,ADCS2	;normal conversion clock(not/2)
	bsf		ADCON1,VCFG1	;Votage ref + sur pin2, RA3,  ici 2.5V
;;;;;;;;;;;;;ADCON0;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	banksel	ADCON0			;bk 0
	clrf	ADCON0
	bsf		ADCON0,ADCS0	;conversion clock	Fosc/8 OK car <5MHz	
	bsf		ADCON0,CHS1		;channel 2, AN2, pin 1
	bcf		DK1			;Diodes off	
	bsf		LED1			;Allumer la LED 3s
	movlw	d'12'			;3s
	call	Wait_ns
	bcf		LED1
	return	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Lec2V						;SUB lit V1 puis 30s aprs, V2 et calcul V1-V2=DIFF>0							;
	call	CONV			;Lit V de l'anode de la diode
	movwf	V1				;V1 premire lecture,  froid
	movlw	d'120'			; 30s on
	call	Wait_ns
	call	CONV			;Lit V de l'anode de la diode
	movwf	V2				;V2 deuxime lecture	
	movfw	V2				;
	subwf	V1,w			;V1-V2 
	movwf	DIFF			;save the difference
	btfsc	STATUS,C		
kjh	
	return					;V1>=V2, OK
	comf	DIFF,f			;V1<V2, DIFF en -DIFF
	incf	DIFF,f
	goto	kjh
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SETUPDELAY					;Attente pour la conversion A to D
	movlw	3
	movwf	TMP
	decfsz	TMP,f
	goto	$-1
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_1ms					;SUB d'attente 1 ms
	movlw	d'250'			;attendre 1ms = 250X4mus
sd	addlw	-1		;                                                  1mus
	btfss	STATUS,Z	;                                                  1
	goto	sd		;                                                  2
	return		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_wms					;SUB attente w ms 
	movwf	cs
	call	wait_1ms
	decfsz	cs,f
	goto	$-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_ns						;SUB d'attente de n/4 s
	movwf	TMP
	movlw	d'100'
	call	WAIT_wms
	decfsz	TMP,f
	goto	$-2
	return
;;;;;;;;;;;;;
	end